//+------------------------------------------------------------------+
//|                                           MMP Multi-Hedge v1.mq4 |
//|                 Copyright  2007, Steve Wilson - SBW Enterprises |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Steve Wilson - SBW Enterprises"
#property link      "http://www.forex-tsd.com"

/*********************************************************************
Currently we are only displaying values on chart. We need to add the
open and close trade functions.

Please add comments to all changes and additions you make so we can 
all follow. Also increase version number to 1.2, 1.3 etc.
                      
                      To Do List
1. Calculate AutoRatio
2. Auto Open Trades when Volatility is below a given point ie 0.9996
3. Close trades when account is in profit. Perhaps when volatility
   is above 1.0004. Maybe use $ value and include swap. ******* Done in v1.2
4. Add Magic number to calculations.
5. Add MoneyManager function to calculate risk and pip size
6. Add Profit Target Function - *********** Done in v1.2
7. Check calculations in function SymbolPrice() to ensure it is correct
8. Option to enter different symbols and EA will calculate correct ratios

*********************************************************************/


extern int        Magic       = 1000;   //Currently not used. Please add functionality.
extern bool       DisplayValues = true; // If false then values not shown on chart
extern bool       Autotrade   = true; 
extern string     Symbol1     = "EURUSD";
extern string     Symbol2     = "USDCHF";
extern string     Symbol3     = "EURCHF";
extern bool       Symbol1isLong = true;
extern bool       Symbol2isLong = true;
extern bool       Symbol3isLong = false;
extern bool       ReverseSymbol3 = true; // Added in v1.1 for EURCHF pairs. Calculation needed 1/EURCHF 
extern bool       Divide1and2 = false;   // Added in v1.1 for GBP/JPY/CHF pairs. See preset values below.
extern double     LotsSize      = 0.01; 
extern bool       UseAutoRatio = true; // Calculation Added in v1.2
extern double     Ratio    = 1; 
extern double     ratio1   = 1;
extern double     ratio2   = 1;
extern double     ratio3   = 1;
extern bool       MoneyManager = true; // Not used yet. Needs to do.
extern double        ProfitTarget=0;    // Added in v1.2 Setting this value will calculate all open trades and close if profit reached.
extern double        MaxLoss=0;    // Added in v1.2 Setting this value will calculate all open trades and close if maximum loss is reached.   


double Symbol1Price=0, Symbol2Price=0, Symbol3Price=0;
double pp=0, pBid=0, volatility=0, v1=0;
double SMA_Value_for_Range = 200;


bool init=true;
bool CloseSignal=false;
bool result;


datetime timeprev=0;

/***************************************************
Preset values for GBP/JPY/CHF
****************************************************
Magic=1000
DisplayValues=1
Autotrade=1
Symbol1=GBPJPY
Symbol2=CHFJPY
Symbol3=GBPCHF
Symbol1isLong=true
Symbol2isLong=false
Symbol3isLong=true
ReverseSymbol3=false
Divide1and2=true
LotsSize=0.01
UseAutoRatio=false
ratio1=1.00000000
ratio2=1.00000000
ratio3=1.00000000
MoneyManager=true
ProfitTarget=0
******************************************************/




//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

SymbolPrice();
ChartComment();

if(ProfitTarget>0)
CloseAllTrades();

   
//----
   return(0);
  }
//+------------------------------------------------------------------+


// Obtaining symbol PRICE for each of our 3 symbols and calculating volatility
void SymbolPrice()
{
   
      
      pp = MarketInfo(Symbol1, MODE_POINT); 
      //if(Symbol1isLong == true) pBid = MarketInfo(Symbol1, MODE_ASK);
      //   else pBid = MarketInfo(Symbol1, MODE_BID); // to determine if we should use ASK or BID price
      pBid = MarketInfo(Symbol1, MODE_ASK); 
      Symbol1Price = pBid;

      pp = MarketInfo(Symbol2, MODE_POINT); 
      //if(Symbol2isLong == true) pBid = MarketInfo(Symbol2, MODE_ASK); 
      //   else pBid = MarketInfo(Symbol2, MODE_BID);
      pBid = MarketInfo(Symbol2, MODE_ASK);
      Symbol2Price = pBid;   

      pp = MarketInfo(Symbol3, MODE_POINT); 
      //if(Symbol3isLong == true) pBid = MarketInfo(Symbol3, MODE_ASK); 
      //   else pBid = MarketInfo(Symbol3, MODE_BID);
      pBid = MarketInfo(Symbol3, MODE_ASK);
      Symbol3Price = pBid;
      
      // For perfect alignment (1.0000) Symbol1Price * Symbol3Price should = Symbol2Price. 
      //Ths may help to calculate auto ratios
      v1 = Symbol1Price * Symbol3Price;
      //volatility = ( v1 - Symbol2Price); // not sure how this should be calculated
      
      //Altered in v1.1
      if(ReverseSymbol3 == true && Divide1and2 == false )
      volatility = Symbol1Price * Symbol2Price * (1/Symbol3Price);
      if(ReverseSymbol3 == false && Divide1and2 == false )
      volatility = Symbol1Price * Symbol2Price * (Symbol3Price);
      
      if(ReverseSymbol3 == true && Divide1and2 == true)
      volatility = Symbol1Price / Symbol2Price / (1/Symbol3Price);
      if(ReverseSymbol3 == false && Divide1and2 == true )
      volatility = Symbol1Price / Symbol2Price / (Symbol3Price);
      
      ratio1 = 1;
      ratio2 = Symbol1Price/Symbol2Price;
      if(Symbol1Price > 10 && Symbol3Price < 10) ratio3 = Symbol1Price/(Symbol3Price * 100);else ratio3 = Symbol1Price/Symbol3Price;
      
   
}


void ChartComment()
{

   if (DisplayValues == true){
      string sComment   = "";
      string sp         = "****************************\n";
      string NL         = "\n";

      sComment = NL + sp;
      sComment = sComment + Symbol1 + " Price = "+ DoubleToStr(Symbol1Price,4) + NL;
      sComment = sComment + Symbol2 + " Price = "+ DoubleToStr(Symbol2Price,4) + NL;
      sComment = sComment + Symbol3 + " Price = "+ DoubleToStr(Symbol3Price,4) + NL;
      sComment = sComment + "Ratio 1            = "+ DoubleToStr(ratio1,2) + NL;
      sComment = sComment + "Ratio 2            = "+ DoubleToStr(ratio2,2) + NL;
      sComment = sComment + "Ratio 3            = "+ DoubleToStr(ratio3,2) + NL;
      

/*      
      sComment = sComment + Symbol1 + " X " + Symbol3 + " = "+ DoubleToStr(Symbol1Price * Symbol3Price,4) + NL;
      //sComment = sComment + "Hedge EUR/USD/CHF: Buy (EUR/USD), Buy (USD/CHF), SellShort (EUR/CHF)" + NL;
      //if(ReverseSymbol3 == true)
      //sComment = sComment + "Calculation = " + Symbol1 +" X "+ Symbol2 +" X " + "(1/" + Symbol3 + ")"+ NL;
      //else
      sComment = sComment + "Calculation = " + Symbol1 +" X "+ Symbol2 +" X " + Symbol3 + NL;
      */
      sComment = sComment + "Volatility Price = "+ DoubleToStr(volatility,4) + NL + NL;
      if(ProfitTarget>0) sComment = sComment + "Profit Target        (USD)= $"+ DoubleToStr(ProfitTarget,2) + NL;
      if(MaxLoss > 0) sComment = sComment + "Maximum Loss     (USD)= $-" + DoubleToStr(MaxLoss,2) + NL;
      
      sComment = sComment + NL + sp;
      Comment(sComment);
   }
}	  


// Close all open trades when in profit
void CloseAllTrades(){
int i=0;

if(ProfitTarget > 0 && AccountProfit() >= ProfitTarget) CloseSignal=true;
if(MaxLoss > 0 && AccountProfit() <= -MaxLoss) CloseSignal=true;

if (CloseSignal){
   for (i=OrdersTotal()-1;i>=0;i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
             if (OrderType()==OP_SELL)result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),3,CLR_NONE);
             if(result!=TRUE) Print("LastError = ", GetLastError());
             if (OrderType()==OP_BUY)result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),3,CLR_NONE);
             if(result!=TRUE) Print("LastError = ", GetLastError());
             if (OrderType()==OP_BUYSTOP)result=OrderDelete(OrderTicket());
             if(result!=TRUE) Print("LastError = ", GetLastError());
             if (OrderType()==OP_SELLSTOP)result=OrderDelete(OrderTicket());
             if(result!=TRUE) Print("LastError = ", GetLastError());

         }
      else Print( "Error when order select ", GetLastError());
      }
   }
      CloseSignal = false;
      //Print ("Close Signal has been reset to ",CloseSignal);   
}





